// Set if trial version or not
var isTrial=false;
var isActivated=false;
// Photo path on the device
var fileURI = null;
var fileName = null;
var fileType = null;
var ratio = null;
var counter = 0;
var handleTipClosed = false;
var imageAngle = 0;
// Variables to handle the picture loading
var currentPic = "";
var picNumber = 0;

// Changing JQueryMobile parameters
$(document).bind("mobileinit", function(){
	$.extend(  $.mobile , {
		loadingMessage : "Please wait. Extracting text and translating (can take up to a minute)..."
	});
});

// Wait for the page to be completely loaded
$(window).bind('load', function(){
	// If the app is in trial
	if(isTrial == true && isActivated == "false"){
		$.mobile.changePage("#trial", {
				transition: "pop",
				role: "page",
				reverse: false,
				changeHash: false
		});
	}
});


$(document).ready(function() {
	// retrieve activation data
	isActivated = localStorage.getItem('isPhotoTranslator3Activated');
	// first execution of the program
	if(isActivated == null){
		// set the default value
		isActivated = "false";
		// store it
		localStorage.setItem('isPhotoTranslator3Activated', isActivated);
	}
	
	
	// Activation code suPhotoTranslatortted
  	$("#activate").click(function(event){
		// check activation code
  		if($("#activationCode").val() == "NF23SJ2"){
			// code ok, activate the app
			isActivated = "true";
			localStorage.setItem("isPhotoTranslator3Activated", "true");
			// thanks the user
			navigator.notification.confirm("Thank you ! Your software has been successfully activated. Restart the app to get all the languages");
			// go back to the previous page
			$.mobile.changePage("#home");
									
		} else {
			// code wrong
			navigator.notification.alert("Sorry, we are unable to activate your product. For any issues, please contact our technical support.");
			
		}
			
	});	
	
	if(isActivated == "true")
		isTrial = false;
	
	// If the app is in trial
	if(isTrial == true){
		// If we are on android
		// Platform specific
		$("#linkToMarketContainer").show();
		
		
	} else {
        // hide the ads
        $(".ad").hide();
    }
	
	// close the trial page
	$("#closeTrial").click(function(){
		changePageToHome();
	});
	
	
	// Album image picker
	$("#selectImageAlbum").click(function(){
		navigator.camera.getPicture(function(imageData) {

			window.resolveLocalFileSystemURI(imageData, pictureSuccess, null);
			
		}, null, { 
			// Image Picker parameters
			sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
			destinationType: Camera.DestinationType.FILE_URI,
			MediaType: Camera.MediaType.PICTURE
		}); 
	});
	
	
	// Camera image picker
	$("#selectImageCamera").click(function(){
        navigator.camera.getPicture(function(imageData) {
            // To factorize
            window.resolveLocalFileSystemURI(imageData, pictureSuccess, null);
            }, null, { 
                // Image Picker parameters
                sourceType: Camera.PictureSourceType.CAMERA,
                destinationType: Camera.DestinationType.FILE_URI,
                MediaType: Camera.MediaType.PICTURE
            }); 
	});
                  

    // Picture successfully taken              
    var pictureSuccess = function(fileEntry){
        // Update the label on the screen
        $("#photoSelection").html("Picture Selected").css("color","limegreen");
        // Get file info : name, uri, type
        fileEntry.file(function(file) { fileType = file.type; }, null);
        fileName = fileEntry.name;
        fileURI = fileEntry.fullPath;
        // reset the image angle
        imageAngle = 0;
        // load the image to set the angle
        loadSelectedImage();
        // scroll to the screen bottom to show the translate button
        $.mobile.silentScroll(300);
    }
                  
	
	
	
	addLanguageOptions();
	
	// Return to the home page
	var changePageToHome = function() {
		$.mobile.changePage( "#main", {
				transition: "pop",
				role: "page",
				reverse: true,
				changeHash: false
		});
	}
	
	
	
	// Load the selected image
	var loadSelectedImage = function() {
        // delete previous picture
        if(currentPic != "")
            $(currentPic).remove();
        // set the image source
        currentPic = "#selectedPicture" + picNumber;
        $(currentPic).attr("src", fileURI);
        picNumber++;                  
	}
	
	
	// The selected image has been loaded
	$('.selectedPic').load(function() {
		
		
		$(this).exifLoad(function() {
			// retrieve the orientation
			var orientation = $(currentPic).exif("Orientation");
			// Perform the orientation based on the image data
			if(orientation == '6')
				//$('#selectedImage').css("webkit-transform", "rotate(90deg)");
				imageAngle = 90;
			else if(orientation == '3')
				//$('#selectedImage').css("webkit-transform", "rotate(180deg)");
				imageAngle = 180;
			else if(orientation == '8')
				//$('#selectedImage').css("webkit-transform", "rotate(-90deg)");
				imageAngle = 270;
		});
		
				
	});
	
	// Enable the temporary disabled buttons
	var enableButtons = function(){
		// Disable transfer button and select lists
		$("#select-language-from").removeAttr('disabled');
		$("#select-language-to").removeAttr('disabled');
		$("#send").removeAttr('disabled');
		$("#selectImageCamera").removeAttr('disabled');
	}
	
	// Enable the temporary disabled buttons
	var disableButtons = function(){
		// Disable transfer button and select lists
		$("#select-language-from").attr('disabled', 'disabled');
		$("#select-language-to").attr('disabled', 'disabled');
		$("#send").attr('disabled', 'disabled');
		$("#selectImageCamera").attr('disabled', 'disabled');
		
	}
	
	
	
	$("#send").click(function() {
		// Showing loading dialog
		$.mobile.showPageLoadingMsg();
		disableButtons();
		// Disable transfer button and select lists
		$(".selectlist").attr('disabled', 'disabled');
		$("#send").attr('disabled', 'disabled');
		$("#selectImageCamera").attr('disabled', 'disabled');
		
		var languageFrom = $("#select-language-from").val();
		var languageTo = $("#select-language-to").val();
		var apiKey = "QdgJmSnWjK";
		
		// Validating fields
		if (fileName == null) {
			$.mobile.hidePageLoadingMsg();
			return navigator.notification.alert("You must select the image.");
		}
		
		// File upload options
		var options = new FileUploadOptions();
		options.fileKey = "image";
		options.fileName = fileName;
		options.mimeType = fileType;
		options.chunkedMode = false;
		
		// Adding language and apikey parameters in the request
		var params = new Object();
		params.language = languageFrom;
		params.target = languageTo;
		params.apikey = apiKey;
		params.output = "json";
		params.engine = "premium";
		if(imageAngle != 0){
			params.rotate = imageAngle;
		}
		
		
		options.params = params;
		// Doing request
		var fileTransfer = new FileTransfer();
		fileTransfer.upload(fileURI, "http://api.ocrapiservice.com/1.0/rest/ocr", function(response) {
			// Request successful
			$.mobile.hidePageLoadingMsg();
			
			// Showing response data
			if (response.responseCode == 200) {
				//$("#resultText").html("Success");
			} else {
				$("#resultText").html("Failed");
			}
			
			// Request successfully completed 
			var data = "result = " + response.response;
			// execute the json code 
			eval(data);
			
			// Print the result on the screen
			$("#txtExtracted").html(result.extractedText);
			$("#txtTranslated").html(result.translatedText);
			
			// Set the "to" language
			// get the selected value on the previous screen
			var selectedLanguageTo = $("#select-language-to option:selected").val();
			$("#select-language-to-result option[value='" + selectedLanguageTo + "']").attr('selected', 'selected');

			enableButtons();
			$.mobile.changePage($("#result"));
		}, function(error) {
			// Request unsuccessful
			$.mobile.hidePageLoadingMsg();
			enableButtons();

			// Showing error dialog
			switch (error.code) {
				case FileTransferError.FILE_NOT_FOUND_ERR: navigator.notification.alert("File not found.", null, "Failed"); break;
			 	case FileTransferError.INVALID_URL_ERR: navigator.notification.alert("Invalid URL.", null, "Failed"); break;
			 	case FileTransferError.CONNECTION_ERR: navigator.notification.alert("Connection error.", null, "Failed"); break;
			}
		}, options);
	});
	
	// The language is changed on the result screen
	$("#select-language-to-result").change(function() {
	
		// Perform a google translate google to get the new translated text
		// Contruct the google translate url
		var googleApiKey = "AIzaSyAZ6tn6DZnXNkMXSykeEYtF_4nv_NTs1XM";
		var sourceLanguage = $("#select-language-from option:selected").val();	 
		var targetLanguage = $("#select-language-to-result option:selected").val();
		var theText = encodeURIComponent($("#txtExtracted").html());

		var url = "https://www.googleapis.com/language/translate/v2?key=" + googleApiKey + "&source=" + sourceLanguage + "&target=" + targetLanguage + "&q=" + theText;
		
		// Perform the request
		$.get(url, function(data) {
			// Request successfully completed 
			var translatedText = data.data.translations[0].translatedText;
			// Print the text on the screen
			$("#txtTranslated").html(translatedText);

		});
		
	});
	
});